from datetime import datetime
from typing import List, Optional, Dict, Any

from janis_core import *
from janis_core.types.common_data_types import Directory, Int, Float, Boolean

Run_Isoncorrect_V0_1_0 = CommandToolBuilder(tool="run_isoncorrect", base_command=["run_isoncorrect"], inputs=[ToolInput(tag="in_fast_q_folder", input_type=Directory(optional=True), prefix="--fastq_folder", doc=InputDocumentation(doc="Path to input fastq folder with reads in clusters\n(default: False)")), ToolInput(tag="in_number_cores_allocated", input_type=Int(optional=True), prefix="--t", doc=InputDocumentation(doc="Number of cores allocated for clustering (default: 8)")), ToolInput(tag="in_kmer_size_default", input_type=Int(optional=True), prefix="--k", doc=InputDocumentation(doc="Kmer size (default: 9)")), ToolInput(tag="in_window_size_default", input_type=Int(optional=True), prefix="--w", doc=InputDocumentation(doc="Window size (default: 10)")), ToolInput(tag="in_xmin", input_type=Int(optional=True), prefix="--xmin", doc=InputDocumentation(doc="Lower interval length (default: 14)")), ToolInput(tag="in_xmax", input_type=Int(optional=True), prefix="--xmax", doc=InputDocumentation(doc="Upper interval length (default: 80)")), ToolInput(tag="in_minimum_fraction_keeping", input_type=Float(optional=True), prefix="--T", doc=InputDocumentation(doc="Minimum fraction keeping substitution (default: 0.1)")), ToolInput(tag="in_exact_instance_limit", input_type=Int(optional=True), prefix="--exact_instance_limit", doc=InputDocumentation(doc="Do exact correction for clusters under this threshold\n(default: 50)")), ToolInput(tag="in_keep_old", input_type=Boolean(optional=True), prefix="--keep_old", doc=InputDocumentation(doc="Do not recompute previous results if\ncorrected_reads.fq is found and has the smae number of\nreads as input file (i.e., is complete). (default:\nFalse)")), ToolInput(tag="in_set_w_dynamically", input_type=Boolean(optional=True), prefix="--set_w_dynamically", doc=InputDocumentation(doc="Set w = k + max(2*k, floor(cluster_size/1000)).\n(default: False)")), ToolInput(tag="in_max_seqs", input_type=Int(optional=True), prefix="--max_seqs", doc=InputDocumentation(doc="Maximum number of seqs to correct at a time (in case\nof large clusters). (default: 1000)")), ToolInput(tag="in_use_rac_on", input_type=Boolean(optional=True), prefix="--use_racon", doc=InputDocumentation(doc="Use racon to polish consensus after spoa (more time\nconsuming but higher accuracy). (default: False)")), ToolInput(tag="in_split_mod", input_type=Int(optional=True), prefix="--split_mod", doc=InputDocumentation(doc="Splits cluster ids in n (default=1) partitions by\ncomputing residual of cluster_id divided by n. this\nparameter needs to be combined with --residual to take\neffect. (default: 1)")), ToolInput(tag="in_residual", input_type=Int(optional=True), prefix="--residual", doc=InputDocumentation(doc="Run isONcorrect on cluster ids with residual (default\n0) of cluster_id divided by --split_mod. (default: 0)")), ToolInput(tag="in_split_wrt_batches", input_type=Boolean(optional=True), prefix="--split_wrt_batches", doc=InputDocumentation(doc="Process reads per batch (of max_seqs sequences)\ninstead of per cluster. Significantly decrease runtime\nwhen few very large clusters are less than the number\nof cores used. (default: False)")), ToolInput(tag="in_out_folder", input_type=Directory(optional=True), prefix="--outfolder", doc=InputDocumentation(doc="Outfolder with all corrected reads. (default: None)\n"))], outputs=[ToolOutput(tag="out_out_folder", output_type=Directory(optional=True), selector=InputSelector(input_to_select="in_out_folder", type_hint=File()), doc=OutputDocumentation(doc="Outfolder with all corrected reads. (default: None)\n"))], container="quay.io/biocontainers/isoncorrect:0.0.7--py_0", version="v0.1.0")


if __name__ == "__main__":
    # or "cwl"
    Run_Isoncorrect_V0_1_0().translate("wdl")

